<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Traits\TResponse;
use FM\Service\Fm0000000EquipesService;

class Fm0000000EquipesController {
    use TResponse;

    protected $EquipesService;

    public function __construct(Fm0000000EquipesService $Fm0000000EquipesService)
    {
        $this->EquipesService = $Fm0000000EquipesService;
    }

    public function getEquipes() {
        try { 
            $data = $this->EquipesService->getEquipes();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarEquipes(Request $request){
        try {
            $params = $request->getParameters();
            $data = $this->EquipesService->salvarEquipes($params["ROW"]);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getOperadorEquipe(Request $request) {
        try {
            $data = $this->EquipesService->getOperadorEquipe($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function relacionarOperadorEquipe(Request $request){
        try {
            $data = $this->EquipesService->relacionarOperadorEquipe($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirEquipes(Request $request){
        try {
            $params = $request->getParameters();
            $data = $this->EquipesService->excluirEquipes($params["ROW"]);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirOperadorEquipe(Request $request){
        try {
            $params = $request->getParameters();
            $data = $this->EquipesService->excluirOperadorEquipe($params["ROW"]);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
}