<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FmtSolicitacaoServService;
use FM\Traits\TResponse;

class FmtSolicitacaoServController
{
    use TResponse;
    protected $SolicitacaoServService;

    public function __construct(FmtSolicitacaoServService $SolicitacaoServService)
    {
        $this->SolicitacaoServService = $SolicitacaoServService;
    }

    public function getSolicitacoesServicos(Request $request)
    {
        try {
            $data = $this->SolicitacaoServService->getSolicitacoesServicos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveRecusarSolicitacoes(Request $request)
    {
        try {
            $parametros = $request->getParameters();
            $this->SolicitacaoServService->saveRecusarSolicitacoes($parametros);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveSolicitacaoServico(Request $request)
    {
        try {
            $parametros = $request->getParameters();
            $this->SolicitacaoServService->saveSolicitacaoServico($parametros);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getImpactoManut(Request $request)
    {
        try {
            $data = $this->SolicitacaoServService->getImpactoManut();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getPrioridadesManut(Request $request)
    {
        try {
            $data = $this->SolicitacaoServService->getPrioridadesManut();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosSolicitacao(Request $request)
    {
        try {
            $parametros = $request->getParameters();
            $data = $this->SolicitacaoServService->getFotosSolicitacao($parametros);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getComentariosSolicitacao(Request $request)
    {
        try {
            $parametros = $request->getParameters();
            $data = $this->SolicitacaoServService->getComentariosSolicitacao($parametros);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insertComentarioSolicitacao(Request $request)
    {
        try {
            $parametros = $request->getParameters();
            $this->SolicitacaoServService->insertComentarioSolicitacao($parametros);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getOperadorLogado(Request $request)
    {
        try {
            $data = $this->SolicitacaoServService->getOperadorLogado();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getOperadores(Request $request)
    {
        try {
            $data = $this->SolicitacaoServService->getOperadores();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFuncionarios(Request $request)
    {
        try {
            $data = $this->SolicitacaoServService->getFuncionarios();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFuncionarioLogado(Request $request)
    {
        try {
            $data = $this->SolicitacaoServService->getFuncionarioLogado();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
